#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "private_methods4xi.py">
#<abstract4xi abstract = "provides function private_methods4xi"/#>
#<refer4xi reference = "DragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'private_methods4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    from traceback import format_exc
    import copyreg         
except:
    pass
try:                 # rare ones
    import array
    import queue          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from all_methods4xi import all_methods4xi
from print4xi import print4xi
from time4xi import time4xi
 
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "private_methods4xi" usage = "
# test_private_methods4xi.py
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def private_methods4xi(obj):
    '''
    private_methods4xi function: returns a list of names of methods of `obj` which do not start with '_'
    '''
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    
    class2print = "private_methods4xi"
    method2print = "private_methods4xi"
    
    message2print = "{started" + "; private-methods4xi-started: " + str(private_methods4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; object-passed-to-private-methods4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
    message2print = "{passing" + "; object-passing-to-all-methods4xi-by-private-methods4xi: " + str(obj) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        

    message2print = "{returning" + "; private-methods-returning-by-private-methods4xi: " + "private methods of an object" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        

    return [name2xi for name2xi in all_methods4xi(obj) if name2xi[0] == '_' or name2xi[1] == '_']
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of private_methods4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



